#!/usr/bin/perl
# Ralf's Chat - a Perl webchat script
# Copyright 1998-2002 Ralf Gueldemeister <ralf@ralfchat.com>
#
# This file is part of Ralf's Chat.
#
# Ralf's Chat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Ralf's Chat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Ralf's Chat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

require "./config.cgi";
require "./shared.cgi";
require "./$lang_dir/$language.cgi";
require "./$html_dir/user_error.cgi";

# Main Part - DON'T CHANGE ANYTHING HERE!
#
#######################

&action;

# <DBI>
$dbh->disconnect if ($use_dbi);
# </DBI>

exit;

sub action {
    if (not $qs) {
        require "./$html_dir/welcome.cgi";
        &welcome;
    } elsif ($query{'action'} eq "chat") {
        &checkpass;
        require "./$html_dir/chat.cgi";
        &chat;
    } else {
        &error;
    } 
}

sub welcome { # Welcome page
    &welcome_html;
}


sub chat {
    &chat_html_header;

    my (@msgfile, @messages, $row);
    my $n = 0;

    if ($use_dbi) {
# <DBI>
        my $sth;
        $sth = $dbh->prepare("SELECT * FROM $data{'messages'} WHERE room=$session{'room'} ORDER BY message_timestamp DESC");
        $sth->execute();
        while ($row = $sth->fetchrow_arrayref and $n < $message_limit) {
            if ($$row[2] =~ /^(\Q$session{'name'}\E)?$/i) {
                push (@messages, [@$row]);
                $n++;
            }
        }
# </DBI>
    } else {
# <NODBI>
        &file_open("messages", "<");
        while (<READFILEMESSAGES>) {
            chomp;
            push (@msgfile, [split(/;;/)]);
        }
        &file_close("messages", "<");
        
        @msgfile = reverse @msgfile;
        
        foreach $row (@msgfile) {
            if ($$row[2] =~ /^(\Q$session{'name'}\E)?$/i and $$row[6] == $session{'room'}) {
                push (@messages, $row);
                $n++;
                last if ($n >= $message_limit);
            }
        }
# </NODBI>
    }
    
    if (not $session{'new_msg_on_top'}) {
        @messages = reverse(@messages);
    }
    
    foreach $row (@messages) {
        if ($$row[0] eq "action") {
            if ($$row[3] eq "loginsound" && $session{'loginsound'}) {
                if ($$row[4] + 1.9*$session{'updatefrequency'} > $timestamp) {
                    print "<EMBED SRC=\"$session{'loginsound'}\" AUTOSTART=TRUE HEIGHT=1 WIDTH=1>";
                }
            }
        } else {
            print "$$row[3]<BR CLEAR=ALL>\n"
        }
    }
    
    &chat_html_footer;
    &saprocess($session{'name'});
}

# EOF
