#!/usr/bin/perl
# Ralf's Chat - a Perl webchat script
# Copyright 1998-2002 Ralf Gueldemeister <ralf@ralfchat.com>
#
# This file is part of Ralf's Chat.
#
# Ralf's Chat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Ralf's Chat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Ralf's Chat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

require "./config.cgi"; 
require "./shared.cgi";
require "./$lang_dir/$language.cgi";
require "./$html_dir/user_error.cgi";
require "./$html_dir/chatframes.cgi";

# Main Part - DON'T CHANGE ANYTHING HERE!
#
#######################


&action; 

# <DBI>
$dbh->disconnect if ($use_dbi);
# </DBI>

exit;

sub action {
	if ($query{'action'} eq "register") {
	require "./$html_dir/register.cgi";
		&register_html;
	}
	elsif ($query{'action'} eq "login") {
		&login;
	}
	elsif ($query{'action'} eq "create_nick") {
		&create_nick;
	}
	elsif ($query{'action'} eq "banner") {
	require "./$html_dir/banner.cgi";
		&banner_html;
	}
	elsif ($query{'action'} eq "options_html") {
	&checkpass;
	require "./$html_dir/options.cgi";
		&options_html;
	}
	elsif ($query{'action'} eq "setoptions") {
	&checkpass;
		&setoptions;
    }
    elsif ($query{'action'} eq "gotourl") {
        &gotourl;
    }
    elsif ($query{'action'} eq "userinfo") {
        &userinfo($query{'infoabout'});
	require "./$html_dir/userinfo.cgi";
	&userinfo_html;
    }
    elsif ($query{'action'} eq "changeuserinfo") {
	&checkpass;
	require "./$html_dir/changeuserinfo.cgi";
	&changeuserinfo;
    }
    elsif ($query{'action'} eq "setuserinfo") {
	&checkpass;
        &setuserinfo;
    }
    elsif ($query{'action'} eq "rooms") {
	&checkpass;
	require "./$html_dir/rooms.cgi";
        &rooms_html;
    }
    elsif ($query{'action'} eq "send_pwd") {
        &send_pwd;
    }
    elsif ($query{'action'} eq "logout") {
	&checkpass;
        &logout;
    }
    elsif ($query{'action'} eq "enterchat") {
	&checkpass;
        &enterchat;
    }
    else {
    	&error;
    } 
}


sub login {	
    if ($clear_old_msgs == 1) {
	&clear_old_msgs_sub;
    }

    my ($nickdata, $nickok);
    if ($use_dbi) {
# <DBI>
	# check if ip is banned
	$sth = $dbh->prepare("SELECT entry FROM $data{'banned'} WHERE LOCATE(entry,'ip:$ENV{'REMOTE_ADDR'}',1) = 1");
	$sth->execute;
	if ($sth->fetchrow_arrayref) {
	    &user_error_html($err_h{'yab'}, $err_t{'yab'});
	    exit;
	}
	$sth = $dbh->prepare("SELECT * FROM $data{'nicks'} WHERE Lower(name) = Lower('$query{'name'}')");
	$sth->execute;
	if ($nickdata = $sth->fetchrow_hashref) {
	    # check pwd
	    if ($$nickdata{'password'} ne $query{'password'}) {
		&user_error_html($err_h{'wp'}, &msgargs($err_t{'wp'},[$query{'name'}]));
		exit;
	    }
	    
	    # check if user is already logged in
	    $sth = $dbh->prepare("SELECT id FROM $data{'stillalive'} WHERE Lower(name) = Lower('$query{'name'}')");
	    $sth->execute;
	    if (my $row = $sth->fetchrow_hashref) {
		if ($$nickdata{'ip'} ne $ENV{'REMOTE_ADDR'}) {
		    &user_error_html($err_h{'uali'}, &msgargs($err_t{'uali'},[$query{'name'}]));
		    exit;
		} else {
		    $query{'id'} = $$row{'id'};
		}
	    }
	    
	    # update last visited date and IP and number of memos
	    $dbh->do("UPDATE $data{'nicks'} SET lvd = $timestamp, ip = '$ENV{'REMOTE_ADDR'}', memos = 0 WHERE name = '$$nickdata{'name'}'");
	    
	    #set unkicked if user was kicked
	    $dbh->do("UPDATE $data{'nicks'} SET banlevel = 0 WHERE name = '$$nickdata{'name'}'") if ($$nickdata{'banlevel'} == 1);
	    
	    #check if user is banned
	    if ($$nickdata{'banlevel'} == 2) {
		&user_error_html($err_h{'yab'}, $err_t{'yab'});
		exit;
	    }
	    $nickok = 1;
	}
# </DBI>
    } else {
# <NODBI>
	# check if ip is banned
	&file_open("banned", "<");
	while (<READFILEBANNED>) {
	    chomp;
	    if ("ip:$ENV{'REMOTE_ADDR'}" =~ /^\Q$_\E/) {
		&user_error_html($err_h{'yab'}, $err_t{'yab'});
		&file_close("banned", "<");
		exit;
	    }
	}
	&file_close("banned", "<");
	
	&file_open("nicks", ">");
	
	my @nickdata;
	while (<READFILENICKS>) {
	    if (/^\Q$query{'name'}\E;;/i) {
		chomp;
		@nickdata = split(/;;/);
		
		# check pwd
		if ($query{'password'} ne $nickdata[1]) {
		    &file_close("nicks", "!");
	    	    &user_error_html($err_h{'wp'}, &msgargs($err_t{'wp'},[$query{'name'}]));
		    exit;
		}
		
		# check if user is already logged in
		&file_open("stillalive", "<");
		while (<READFILESTILLALIVE>) {
		    if (/^\Q$query{'name'}\E;;/i) {
			if ($nickdata[11] ne $ENV{'REMOTE_ADDR'}) {
			    &file_close("nicks", "!");
		    	    &file_close("stillalive", "<");
			    &user_error_html($err_h{'uali'}, &msgargs($err_t{'uali'},[$query{'name'}]));
		    	    exit;
			} else {
			    my @row = split(/;;/);
			    $query{'id'} = $row[4];
			}
			last;
		    }
		}
		&file_close("stillalive", "<");
		
		$$nickdata{'name'}            = $nickdata[0];
		$$nickdata{'password'}        = $nickdata[1];
		$$nickdata{'email'}           = $nickdata[2];
		$$nickdata{'updatefrequency'} = $nickdata[5];
		$$nickdata{'color'}           = $nickdata[6];
		$$nickdata{'streaming'}       = $nickdata[8];
		$$nickdata{'new_msg_on_top'}  = $nickdata[9];
		$$nickdata{'loginsound'}      = $nickdata[13];
		$$nickdata{'memos'}           = $nickdata[12];
		$$nickdata{'userlevel'}       = $nickdata[7];
		
		# update last visited date and IP and number of memos
		$nickdata[4]  = $timestamp;
		$nickdata[11] = $ENV{'REMOTE_ADDR'};
		$nickdata[12] = 0;
		
		#set unkicked if user was kicked
		$nickdata[10] = 0 if ($nickdata and $nickdata[10] == 1);
		
		#check if user is banned
		if ($nickdata[10] == 2) {
		    &user_error_html($err_h{'yab'}, $err_t{'yab'});
		    &file_close("nicks", "!");
		    exit;
		}
		print WRITEFILENICKS join(';;', @nickdata)."\n";
		
		$nickok = 1;
	    } else {
		print WRITEFILENICKS;
	    }
	}
	&file_close("nicks", ">");
# </NODBI>
    }

    if (not $nickok) {
	&user_error_html($err_h{'unf'}, &msgargs($err_t{'unf'}, [$query{'name'}]));
	exit;
    }
    
    %session = %$nickdata;

    # check if chat is full
    if ($session{'userlevel'} == 0 and $max_users >= 0 and &number_of_users >= $max_users) {
        &user_error_html($err_h{'cif'}, $err_t{'cif'});
        exit;
    }

    if ($query{'room'} and $query{'room'} != $session{'room'}) {
	$session{'room'} = $query{'room'};
    } else {
	$session{'room'} = $room;
    }    
    
    if (not $query{'id'}) {
	# post welcome msg
	&postmsg("plain", $session{'name'}, "", &msgargs($msg{'hetc'}, [$session{'name'}]));
	
	# create session
	my $n;
	for ($n=0; $n<$sid_length; $n++) {
	    $query{'id'} .= chr(int(rand(26)+97));
	}
	if ($use_dbi) {
# <DBI>
	    $dbh->do("INSERT INTO $data{'stillalive'} VALUES ('$session{'name'}', $timestamp, 0, $session{'userlevel'}, '$query{'id'}', '$session{'password'}', '$session{'email'}', $session{'updatefrequency'}, '$session{'color'}', $session{'new_msg_on_top'}, '$session{'loginsound'}', $session{'streaming'}, $session{'room'})");
# </DBI>
	} else {
# <NODBI>
	    &file_open("stillalive", "a");
    	    print APPENDFILESTILLALIVE join(';;', ($session{'name'}, $timestamp, 0, $session{'userlevel'}, $query{'id'}, $session{'password'}, $session{'email'}, $session{'updatefrequency'}, $session{'color'}, $session{'new_msg_on_top'}, $session{'loginsound'}, $session{'streaming'}, $session{'room'}))."\n";
	    &file_close("stillalive", "a");
# </NODBI>
	}
    } else {
	# post reenter msg
	&postmsg("plain", $session{'name'}, "", &msgargs($msg{'hrtc'}, [$session{'name'}]));
    }

    # post welcome msg
    &postmsg("plain", "WELCOME", $session{'name'}, $msg{'welco'});
    
    # check memos
    if ($session{'memos'} > 0) {
	$pause = 1;
	&check_for_memo;
    }

    &enterchat;
}

sub enterchat {
    # change room
    if ($query{'room'} and $query{'room'} != $session{'room'}) {
	my $oldroom = $session{'room'}; my $newroom = $query{'room'};
	&postmsg("plain", $session{'name'}, "", &msgargs($msg{'gt'}, [$session{'name'},$rooms{$newroom}]));
	$session{'room'} = $query{'room'};
	&postmsg("plain", $session{'name'}, "", &msgargs($msg{'cf'}, [$session{'name'},$rooms{$oldroom}]));
	&saprocess($session{'name'}, $session{'room'});
    } else {
	$session{'room'} = $room;
    }

    #post room welcome msg
    if ($welcome_msgs{$session{'room'}} ne "") {
	&postmsg("plain", "WELCOME", $session{'name'}, $welcome_msgs{$session{'room'}});
    }
    # Login msg + sound
    $nothing = "";
    &postmsg("action", $session{'name'}, "", "loginsound$nothing");
    
    &logfile("[LOGIN] ($rooms{$session{'room'}}) $session{'name'}", 2);

    &chatframes_html;
}

sub create_nick {		# create new nick and redirect to chat
    # check if nick contains illegal chars
    if ($international_nicks) {
	if ($query{'name'} =~ /[\";\/:\\\?\*<>\| \']/ or not $query{'name'}) {
	    &user_error_html($err_h{'iu'}, &msgargs($err_t{'iu'}, [$query{'name'}]));
	    exit;
	}
    } else {
	if ($query{'name'} =~ /[\W]/ or !$query{'name'}) {
	    &user_error_html($err_h{'in'}, &msgargs($err_t{'in'}, [$query{'name'}]));
	    exit;
	}
    }

    # check if nick is too long
    if (length($query{'name'}) > $max_input_length) {
        &user_error_html($err_h{'utl'}, &msgargs($err_t{'utl'},[$query{'name'},$max_input_length]));
        exit;
    }

    # check if password is too long
    if (length($query{'password'}) > $max_input_length) {
        &user_error_html($err_h{'ptl'}, &msgargs($err_t{'ptl'},[$max_input_length]));
        exit;
    }

    # check if password contains illegal chars
    if ($query{'password'} =~ /[;\']/ or !$query{'password'}) { 
        &user_error_html($err_h{'ip'}, $err_t{'ip'});
        exit;
    }
    
    # check if 2 passwords are equal
    if ($query{'password'} ne $query{'password2'}) {
        &user_error_html($err_h{'pcf'}, $err_t{'pcf'});
        exit;
    }

    
    if ($use_dbi) {
# <DBI>
	$sth = $dbh->prepare("SELECT name FROM $data{'nicks'} WHERE Lower(name) = Lower('$query{'name'}')");
	$sth->execute;
	if ($sth->fetchrow_arrayref) {
	    &user_error_html($err_h{'uae'}, $err_t{'uae'});
	    exit;
	}
	$sth = $dbh->do("INSERT INTO $data{'nicks'} VALUES ('$query{'name'}', '$query{'password'}', '$query{'email'}', $timestamp, $timestamp, '$updatefrequency', 'standard', $new_msg_on_top, 0, '$ENV{'REMOTE_ADDR'}', 0, NULL, 0, 0)");
# </DBI>
    } else {
# <NODBI>
	&file_open("nicks", "<");
	
	# does nick already exist?
	while (<READFILENICKS>) {
	    chomp;
	    if (/^\Q$query{'name'}\E;;/i) {
		&user_error_html($err_h{'uae'}, $err_t{'uae'});
		&file_close("nicks", "<");
		exit;
	    }
	}
	
	&file_close("nicks", "<");
	
	my @nickdata;
	$nickdata[0] = $query{'name'};
	$nickdata[1] = $query{'password'};    
	$nickdata[2] = $query{'email'};
	$nickdata[3] = $timestamp;
	$nickdata[4] = $timestamp;
	$nickdata[5] = $updatefrequency;
	$nickdata[6] = "standard";
	$nickdata[7] = 0;
	$nickdata[8] = 0;
	$nickdata[9] = $new_msg_on_top;
	my $nickentry = join(';;', @nickdata);
	
	&file_open("nicks", "a");	
	print APPENDFILENICKS "$nickentry\n";
	&file_close("nicks", "a");
# </NODBI>
    }

    #MAIL TO ADMIN
    if ($mail_on_new_registration == 1) {
	open(MAIL,"|$mailprogramme -t");
	print MAIL "To: $admin_email_addresse\n";
	print MAIL "From: $admin_email_addresse (Ralfs Chat Script)\n";
	print MAIL "Subject: [CHAT] New Nick Registration\n\n";
	print MAIL "A new user was registered\n";
	print MAIL "Nickname: $query{'name'}\n";
	print MAIL "eMail: $query{'email'}\n";
	print MAIL "HTTP User Agent: ".$ENV{'HTTP_USER_AGENT'}."\n";
	print MAIL "Remote Addresse: ".$ENV{'REMOTE_ADDR'}."\n";
	close MAIL;
    }
    
    &logfile("[NEW USER] $query{'name'} <$query{'email'}>", 1);

    # delete old users
    if ($days_del_old_users >= 0) {
	&remove_nick("", $days_del_old_users);
    }
    
    &login;
}

sub clear_old_msgs_sub {
    &saprocess;
    if ($use_dbi) {
# <DBI>
	my $sth = $dbh->prepare("SELECT name FROM $data{'stillalive'}");
	$sth->execute;

	# if no rows in table stillalive clear messages
	if (!$sth->fetchrow_arrayref ) {
	    $dbh->do("DELETE FROM $data{'messages'}");
	}
# </DBI>
    } else {
# <NODBI>
	# if stillalive file has zero size clear messages
	if (-s "$data_dir/$data{'stillalive'}" < 11) {
	    open(MSGFILE, ">$data_dir/$data{'messages'}");
	    close MSGFILE;
	}
# </NODBI>
    }
}

sub setoptions {    
    if ($query{'new_updatefrequency'}<$min_update_freq || $query{'new_updatefrequency'} eq "") {
	$query{'new_updatefrequency'}=$min_update_freq;
    }
    if ($query{'new_loginsound'}) {
	$query{'new_loginsound'} =~ s/^(file:)?(\/\/)?(localhost)?\/?(.*)/file:\/\/localhost\/$4/;
    }
    # remove anything from color tag
    $query{'new_color'} =~ s/.*([0-9A-F]{6}).*/$1/;
    
    if ($query{'change_pwd_new'}) {
	if ($query{'change_pwd_old'} eq $session{'password'}) {
	    if ($query{'change_pwd_new'} eq $query{'change_pwd_new2'}) {
		if (length($query{'change_pwd_new'}) > $max_input_length) {
		    &postmsg("command", "CHANGE_PWD", "$session{'name'}", &msgargs($msg{'ypitl'}, [$max_input_length]));
		} elsif ($query{'change_pwd_new'} =~ /[;\'\n]/) { 
		    &postmsg("command", "CHANGE_PWD", "$session{'name'}", $msg{'tnpmn'});
		} else {
		    &postmsg("command", "CHANGE_PWD", "$session{'name'}", $msg{'pc'});
		    $session{'password'} = $query{'change_pwd_new'};
		}
	    } else {
		&postmsg("command", "CHANGE_PWD", "$session{'name'}", $msg{'npcfp'});
	    }
	} else {
	    &postmsg("command", "CHANGE_PWD", "$session{'name'}", $msg{'wp'});
	}
    }
    
    if ($use_dbi) {
# <DBI>
	$dbh->do("UPDATE $data{'nicks'} SET email = '$query{'new_email'}', password = '$session{'password'}', updatefrequency = '$query{'new_updatefrequency'}', color = '$query{'new_color'}', new_msg_on_top = '$query{'new_new_msg_on_top'}', loginsound = '$query{'new_loginsound'}', streaming = '$query{'new_streaming'}' WHERE Lower(name) = Lower('$session{'name'}')");
	$dbh->do("UPDATE $data{'stillalive'} SET email = '$query{'new_email'}', password = '$session{'password'}', updatefrequency = '$query{'new_updatefrequency'}', color = '$query{'new_color'}', new_msg_on_top = '$query{'new_new_msg_on_top'}', loginsound = '$query{'new_loginsound'}', streaming = '$query{'new_streaming'}' WHERE Lower(name) = Lower('$session{'name'}')");
# </DBI>
    } else {
# <NODBI>
	&file_open("nicks", ">");
		
	while (<READFILENICKS>) {
	    if (/^\Q$session{'name'}\E;;/i) {
		chomp;
		my @row = split(/;;/);
		$row[1]  = $session{'password'};
		$row[2]  = $query{'new_email'};
		$row[5]  = $query{'new_updatefrequency'};
		$row[6]  = $query{'new_color'};
		$row[8]  = $query{'new_streaming'};
		$row[9]  = $query{'new_new_msg_on_top'};
		$row[13] = $query{'new_loginsound'};
		print WRITEFILENICKS join(';;', @row)."\n";
	    } else {
		print WRITEFILENICKS;
	    }
	}
	
	&file_close("nicks", ">");
	
	&file_open("stillalive", ">");	
	while (<READFILESTILLALIVE>) {
	    if (/^\Q$session{'name'}\E;;/i) {
		chomp;
		my @row = split(/;;/);
		$row[5]  = $session{'password'};
		$row[6]  = $query{'new_email'};
		$row[7]  = $query{'new_updatefrequency'};
		$row[8]  = $query{'new_color'};
		$row[11] = $query{'new_streaming'};
		$row[9]  = $query{'new_new_msg_on_top'};
		$row[10] = $query{'new_loginsound'};
		print WRITEFILESTILLALIVE join(';;', @row)."\n";
	    } else {
		print WRITEFILESTILLALIVE;
	    }
	}
	
	&file_close("stillalive", ">");
# </NODBI>
    }

    if ($session{'streaming'}) {
        print "Location: $scriptst_name?action=stream&id=$query{'id'}\n\n";
    } else {
        print "Location: $script_name?action=chat&id=$query{'id'}#end\n\n";
    }
}

sub setuserinfo {
    &quote($query{'realname'});
    &quote($query{'email'});
    &quote($query{'age'});
    &quote($query{'city'});
    &quote($query{'country'});
    &quote($query{'url'});
    &quote($query{'stuff'});
    &quote($query{'photo_url'});
    &quote($query{'icq_uin'});


    if ($use_dbi) {
# <DBI>
	$dbh->do("DELETE FROM $data{'userinfo'} WHERE Lower(name) = Lower('$session{'name'}')");
	$dbh->do("INSERT INTO $data{'userinfo'} VALUES('$session{'name'}', '$query{'realname'}', '$query{'email'}', '$query{'age'}', '$query{'city'}', '$query{'country'}', '$query{'url'}', '$query{'stuff'}', '$query{'photo_url'}', '$query{'icq_uin'}')");
# </DBI>
    } else {
# <NODBI>
	&file_open("userinfo", ">");
	
	while (<READFILEUSERINFO>) {
	    if (!/^\Q$session{'name'}\E;;/i) {
		print WRITEFILEUSERINFO;
	    }
	}

	my @row;
	$row[0] = $session{'name'};
	$row[1] = $query{'realname'};
	$row[2] = $query{'email'};
	$row[3] = $query{'age'};
	$row[4] = $query{'city'};
	$row[5] = $query{'country'};
	$row[6] = $query{'url'};
	$row[7] = $query{'stuff'};
	$row[8] = $query{'photo_url'};
	$row[9] = $query{'icq_uin'};

	print WRITEFILEUSERINFO join(';;', @row)."\n";
	
	&file_close("userinfo", ">");
# </NODBI>
    }

    if ($session{'streaming'}) {
        print "Location: $scriptst_name?action=stream&id=$query{'id'}\n\n";
    } else {
        print "Location: $script_name?action=chat&id=$query{'id'}#end\n\n";
    }
}


sub changeuserinfo {
    &userinfo($session{'name'});
    &unquote($userinfo{'stuff'});
    &changeuserinfo_html;
}

sub check_for_memo {
    my $old_time = time - $days_to_keep_memos*60*60*24;
    if ($use_dbi) {
# <DBI>
	# delete old memos (older than $days_to_keep_memos
	$dbh->do("DELETE FROM $data{'memo'} WHERE memo_date < $old_time");

	# get and post memos
	my $sth = $dbh->prepare("SELECT * FROM $data{'memo'} WHERE Lower(memo_to) = Lower('$session{'name'}')");
	$sth->execute;
	my @row;
	while (@row = $sth->fetchrow_array) {
	    $n++;
	    &postmsg("memo", "MEMO", $session{'name'}, &msgargs($msg{'mf2'}, [$row[1],strftime($posting_time_format, localtime($row[3])),$row[2]]));
	}

	# delete memos for $session{'name'}
	$dbh->do("DELETE FROM $data{'memo'} WHERE Lower(memo_to) = Lower('$session{'name'}')");
# </DBI>
    } else {
# <NODBI>
	&file_open("memo", ">");	

	my @row;
	while (<READFILEMEMO>) {
	    chomp;
	    @row = split(/;;/);
	    if ($row[3] < $old_time) { # remove old memos
	    } elsif (/^\Q$session{'name'}\E;;/i) { # get & post & delete memos for $session{'name'}
		&postmsg("memo", "MEMO", $session{'name'},&msgargs($msg{'mf2'}, [$row[1], strftime($posting_time_format, localtime($row[3])), $row[2]]));
	    } else {
		print WRITEFILEMEMO "$_\n";
	    }
	}
	
	&file_close("memo", ">");
# </NODBI>
    }
}

sub send_pwd {
    if ($use_dbi) {
# <DBI>
	my $sth = $dbh->prepare("SELECT email, password FROM $data{'nicks'} WHERE Lower(name) = Lower('$query{'name'}')");
	$sth->execute;
	my @row = $sth->fetchrow_array;
	$query{'email'}    = $row[0];
	$query{'password'} = $row[1];
# </DBI>
    } else {
# <NODBI>
	&file_open("nicks", "<");
	while (<READFILENICKS>) {
	    if (/^\Q$query{'name'}\E;;/i) {
		chomp;
		my @row = split(/;;/);
		$query{'email'}    = $row[2];
		$query{'password'} = $row[1];
		last;
	    }
	}
	&file_close("nicks", "<");
# </NODBI>
    }
    
    if ($query{'email'}) {
	# mail to user
	open(MAIL,"|$mailprogramme -t");
	print MAIL &msgargs($msg{'lpwem'},[$query{'email'},$admin_email_addresse,$html_title,$query{'password'},$query{'name'}]);
	close MAIL;
	
	&user_error_html($err_h{'lp'}, $err_t{'lp'});
    } else {
	&user_error_html($err_h{'lp2'}, $err_t{'lp2'});
    }	
}


sub logout {
    if ($use_dbi) {
# <DBI>
	$dbh->do("DELETE FROM $data{'stillalive'} WHERE Lower(name) = Lower('$session{'name'}')");
# </DBI>
    } else {
# <NODBI>
	&file_open("stillalive", ">");
	while (<READFILESTILLALIVE>) {
	    if (!/^\Q$session{'name'}\E;;/i) {
		print WRITEFILESTILLALIVE;
	    }
	}
	
	&file_close("stillalive", ">");
# </NODBI>
    }

    &logfile("[LOGOUT] $session{'name'}", 2);
    &postmsg("command","LOGOUT","", &msgargs($msg{'hltc'}, [$session{'name'}]));
    print "Location: $scriptgu_name?$logout_url\n\n";
}

# EOF
