#!/usr/bin/perl
# Ralf's Chat - a Perl webchat script
# Copyright 1998-2002 Ralf Gueldemeister <ralf@ralfchat.com>
#
# This file is part of Ralf's Chat.
#
# Ralf's Chat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Ralf's Chat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Ralf's Chat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

require "config.cgi";
require "shared.cgi";

$script_name = "dbi.cgi";

# Main Part
##########################################

my $primary_key;
$primary_key = " PRIMARY KEY" if ($use_primary_keys);

$sql{'nicks'}      = "CREATE TABLE $data{'nicks'} (name varchar(255)$primary_key, password varchar(255), email varchar(255), doc varchar(30), lvd integer, updatefrequency integer, color char(8), new_msg_on_top integer, banlevel integer, ip char(15), memos integer, loginsound text, userlevel integer, streaming integer)";
$sql{'userinfo'}   = "CREATE TABLE $data{'userinfo'} (name varchar(255)$primary_key, realname varchar(255), email varchar(255), age varchar(255), city varchar(255), country varchar(255), url text, stuff text, photo_url text, icq_uin varchar(255))";
$sql{'memo'}       = "CREATE TABLE $data{'memo'} (memo_to varchar(255), memo_from varchar(255), message text, memo_date integer)";
$sql{'messages'}   = "CREATE TABLE $data{'messages'} (type varchar(255), message_from varchar(255), message_to varchar(255), message text, message_timestamp integer, message_id char(30)$primary_key, room integer)";
$sql{'stillalive'} = "CREATE TABLE $data{'stillalive'} (name varchar(255)$primary_key, sa_timestamp integer, away integer, userlevel integer, id char(50), password varchar(255), email varchar(255), updatefrequency integer, color char(8), new_msg_on_top integer, loginsound text, streaming integer, room integer)";
$sql{'banned'}     = "CREATE TABLE $data{'banned'} (entry varchar(255)$primary_key)";


print "<H2>DBI</H2>";

use DBI;

if ($query{'action'} and $query{'password'} ne $masterpassword) {
    print "Wrong masterpassword";
} elsif ($query{'action'} =~ /dbi_view/i) {
    &dbi_view;
} elsif ($query{'action'} =~ /file_view/i) {
    &file_view;
} elsif ($query{'action'} =~ /update_file_to_dbi/i) {
    &update_file_to_dbi;
} elsif ($query{'action'} =~ /dbi_create_all_tables/i) {
    &dbi_create_all_tables;
} elsif ($query{'action'} =~ /import_file/i) {
    &import_file;
} elsif ($query{'action'} =~ /dbi_drop_table/i) {
    &dbi_drop_table;
} elsif ($query{'action'} =~ /dbi_sql/i) {
    &dbi_sql;
} elsif ($query{'action'} =~ /dbi_create_table/i) {
    &dbi_create_table;
} else { 
    print << "[END]";
<FORM ACTION="$script_name" METHOD="POST">
<B>Masterpassword</B>: <INPUT TYPE=PASSWORD NAME="password">
<P>
<TABLE>
<TR><TD VALIGN=TOP><INPUT TYPE=RADIO NAME="action" VALUE="dbi_view"></TD><TD><B>view dbi</B></TD></TR>
<TR><TD VALIGN=TOP><INPUT TYPE=RADIO NAME="action" VALUE="file_view"></TD><TD><B>view file</B></TD></TR>
<TR><TD VALIGN=TOP><INPUT TYPE=RADIO NAME="action" VALUE="update_file_to_dbi"></TD><TD><B>update from file to dbi</B>: Remove messages, banned, private.* and stillalive. Create tables. Import nicks, memo and userinfo. Hint: nicks and passwords containing \' will become unusable.</TD></TR>
<TR><TD VALIGN=TOP><INPUT TYPE=RADIO NAME="action" VALUE="dbi_create_all_tables"></TD><TD><B>create dbi tables</B></TD></TR>
<TR><TD VALIGN=TOP><INPUT TYPE=RADIO NAME="action" VALUE="import_file"></TD><TD><B>import nicks, memos and userinfo from <INPUT TYPE=TEXT NAME="path"></B> (local path)</TD></TR>
<TR><TD VALIGN=TOP><INPUT TYPE=RADIO NAME="action" VALUE="dbi_drop_table"></TD><TD><B>drop table</B> <INPUT TYPE=TEXT NAME="table"></TD></TR>
<TR><TD VALIGN=TOP><INPUT TYPE=RADIO NAME="action" VALUE="dbi_sql"></TD><TD><B>show SQL statements</B>: for phpMyAdmin or other clients</TD></TR>
<TR><TD VALIGN=TOP><INPUT TYPE=RADIO NAME="action" VALUE="dbi_create_table"></TD><TD><B>create table</B>
<SELECT NAME="table_type">
[END]

    while ((my $key, my $value) = each %sql) {
	print "<OPTION VALUE=\"$key\">$key\n";
    }
    print << "[END]";
</SELECT> as <INPUT TYPE=TEXT NAME="table_name"> - for multiple rooms create different messages and stillalive tables
</TD></TR>
</TABLE>
<P>
<INPUT TYPE=RESET><INPUT TYPE=SUBMIT>
</FORM>
[END]

}

print "<P>time expired: ".(times)[0]."s";

$dbh->disconnect;

exit;

####subs



sub dbi_view {
    $tabsth = $dbh->table_info();
    while ($table = $tabsth->fetchrow_arrayref) {
	$sth = $dbh->prepare("SELECT * FROM @$table[2]");
	$sth->execute();
	
	print "<H3>@$table[2]</H3>";
	print "<TABLE BORDER>";
	for ($i = 0; $i < $sth->{NUM_OF_FIELDS}; $i++) { 
	    print "<TH>$sth->{NAME}->[$i]</TH>";
	}
	while ($row = $sth->fetchrow_arrayref) {
	    print "<TR>";
	    foreach (@$row) {
		print "<TD>$_&nbsp;</TD>";
	    }
	    print "</TR>\n"; 
	}
	print "</TABLE>";
    }
    
}

sub file_matrix {
    open(FILE, "<$data_dir/$_[0]");
    my @file_matrix;
    undef @file_matrix;
    while (<FILE>) {
	chomp;
	s/\'/&\#39; /g;		 
	push(@file_matrix, [split(/;;/)]);
    }
    close FILE;
    return @file_matrix;
}

sub file_matrix_view {
    print "<TABLE BORDER>";
    print "<TH>$_[0]</TH>";
    foreach (&file_matrix($_[0])) {
	print "<TR>";
	foreach (@$_) {
	    print "<TD>$_&nbsp;</TD>";
	}
	print "</TR>\n"; 
    }
    print "</TABLE>";
}

sub file_view {
    opendir(DIR, "$data_dir");
    while ($direntry = readdir(DIR)) {
	if (-f "$data_dir/$direntry") {
	    &file_matrix_view($direntry);
	}
    }
    closedir DIR;
}

sub import_file {
    # insert value from files to dbi
    foreach (&file_matrix("nicks")) {
	@$_[4] = 0 if (!@$_[4]);
	@$_[5] = 0 if (!@$_[5]);
	@$_[9] = 0 if (!@$_[9]);
	@$_[10] = 0 if (!@$_[10]);
	@$_[12] = 0 if (!@$_[12]);
	$sth = $dbh->prepare("SELECT name FROM $data{'nicks'} WHERE LOWER(name) = LOWER('@$_[0]')");
	$sth->execute;
	if (not $sth->fetchrow_arrayref) {
	    $dbh->do("INSERT INTO $data{'nicks'} VALUES ('@$_[0]', '@$_[1]', '@$_[2]', '@$_[3]', @$_[4], @$_[5], '@$_[6]', @$_[9], @$_[10], '@$_[11]', @$_[12], '@$_[13]', '@$_[7]', 0)");
	    print "nicks: import @$_[0]<BR>\n";
	} else {
	    print "nicks: import @$_[0] failed<BR>\n";
	}
    }
    
    foreach (&file_matrix("userinfo")) {
	$sth = $dbh->prepare("SELECT name FROM $data{'userinfo'} WHERE LOWER(name) = LOWER('@$_[0]')");
	$sth->execute;
	if (not $sth->fetchrow_arrayref) {
	    $sth = $dbh->do("INSERT INTO $data{'userinfo'} VALUES ('@$_[0]', '@$_[1]', '@$_[2]', '@$_[3]', '@$_[4]', '@$_[5]', '@$_[6]', '@$_[7]', '@$_[8]', '@$_[9]')"); 
	    print "userinfo: import @$_[0]<BR>\n";
	} else {
	    print "userinfo: import @$_[0] failed<BR>\n";
	}
    }
    foreach (&file_matrix("memo")) {
	@$_[3] = time if (!@$_[3]);
	$sth = $dbh->do("INSERT INTO $data{'memo'} VALUES ('@$_[0]', '@$_[1]', '@$_[2]', @$_[3])"); 
    }
}

sub update_file_to_dbi {
    # remove files that can't be updated
    unlink("$data_dir/$data{'messages'}");
    unlink("$data_dir/$data{'stillalive'}");
    unlink(glob("$data_dir/private.*"));
    unlink("$data_dir/$data{'banned'}");
    
    # create tables
    &dbi_create_all_tables;
    
    # remove old content of tables in case of double update
    $sth = $dbh->do("DELETE FROM $data{'nicks'}");
    $sth = $dbh->do("DELETE FROM $data{'userinfo'}");
    $sth = $dbh->do("DELETE FROM $data{'memo'}");
    
    &import_file;
    
}

sub dbi_create_all_tables {
    while ((my $key, my $value) = each %sql) {
	$dbh->do($value);
    }
}

sub dbi_drop_table {
    $dbh->do("DROP TABLE $query{'table'}");
}

sub dbi_sql {
    print "<PRE>";
    while ((my $key, my $value) = each %sql) {
	print "$value\n";
    }
    print "</PRE>";
}

sub dbi_create_table {
    $sql{$query{'table_type'}} =~ s/^CREATE TABLE (\w+) \(/CREATE TABLE $query{'table_name'} \(/;
    $dbh->do($sql{$query{'table_type'}});
}

# EOF
