#!/usr/bin/perl
# Ralf's Chat - a Perl webchat script
# Copyright 1998-2002 Ralf Gueldemeister <ralf@ralfchat.com>
#
# This file is part of Ralf's Chat.
#
# Ralf's Chat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Ralf's Chat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Ralf's Chat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Main Part - DON'T CHANGE ANYTHING HERE!
#
#######################

$about_msg = "Ralf's Chat - <A HREF=\"$scriptgu_name?http://www.ralfchat.com\" TARGET=\"ralfchat\">www.ralfchat.com</A> -  Copyright 2002 Ralf G&uuml;ldemeister \&lt;ralf\@ralfchat.com> on 1998-12-25; last modified on 2002-08-19; Version 1.1.1<BR>This software is released under the terms of the <A HREF=\"$scriptgu_name?http://www.gnu.org/licenses/gpl.html\" TARGET=\"_blank\">GNU General Public License</A> and comes with ABSOLUTELY NO WARRANTY."; # msg printed on /about

# perl modules
# <DBI>
if ($use_dbi) { 
    require DBI;
    import DBI;
}
# </DBI>
use POSIX qw(strftime);
use File::Copy;

$timestamp = time - $time_difference*3600 ;

# initialize random number generator
srand(time() ^ ($$ + ($$ << 10)));

# set standard room
$session{'room'} = $room;

# <DBI>
&connect_db if ($use_dbi);
# </DBI>

&getquery;

if (not $query{'noheader'}) {
    &header;
}


sub extract_qs { # extract variables from $qs --> hash $query
    my @split = split (/&/, $qs);
    foreach $split (@split) {
	($query_key, $query_value) = split (/=/, $split);
	$query_value =~ tr/+/ /;
	$query_value =~ s/%([\dA-Fa-f][\dA-Fa-f])/ pack ("C", hex ($1))/eg;
	$query{$query_key} = $query_value;
    }

}

sub getquery { # get query string
    if ($ENV{'REQUEST_METHOD'} eq "GET") {
	$qs = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
	read(STDIN, $qs, $ENV{'CONTENT_LENGTH'});
    }
    $qs =~ s/;;//g;
    &extract_qs;
    foreach (('action','color','name','password','updatefrequency','new_msg_on_top','ls','streaming','change_pwd_new','room')) {
	if ($query{$_}) {
	    $query{$_} =~ s/[;\r\n\t\f<'>\"]//gi;
	}
    }
}

sub header { # standard html header
    print "Content-type: text/html\n\n";
}

sub error { # $_[0] - error_msg
    print <<"[END]";
<HTML>
<HEAD><TITLE>$html_title - An Error Occured</TITLE>
$html_css
</HEAD>
$html_bodytag
<H1>An Error Occured</H1>
<B>Error Message: $_[0]<BR>Query_String: $qs</B>
</BODY>
</HTML>
[END]
    exit;
}

sub checkpass {
    my ($nickok, @row);
    if ($use_dbi) {
# <DBI>
	my $sth = $dbh->prepare("SELECT * FROM $data{'stillalive'} WHERE id = '$query{'id'}'");
	$sth->execute;
	if (@row = $sth->fetchrow_array) {
	    $nickok      = 1;
	}
# </DBI>
    } else {
# <NODBI>
	&file_open("stillalive", "<");

	while (<READFILESTILLALIVE>) {
	    chomp;
	    @row = split(/;;/);
	    if ($row[4] eq $query{'id'}) {
		$nickok      = 1;
		last;
	    }
	}

	&file_close("stillalive", "<");
# </NODBI>
    }

    if ($nickok) {
	$session{'name'}            = $row[0];
	$userlevel                  = $row[3];
	$session{'password'}        = $row[5];
	$session{'email'}           = $row[6];
	$session{'updatefrequency'} = $row[7];
	$session{'color'}           = $row[8];
	$session{'new_msg_on_top'}  = $row[9];
	$session{'loginsound'}      = $row[10];
	$session{'streaming'}       = $row[11];
	$session{'room'}            = $row[12];
    } elsif (not $query{'noheader'}) { 
	&user_error_html($err_h{'isid'}, $err_t{'isid'});
	exit;
    }
}

sub userinfo { # 0 - infoabout
    my @row;
    if ($use_dbi) {
# <DBI>
	my $sth = $dbh->prepare("SELECT * FROM $data{'userinfo'} WHERE Lower(name) = Lower('$_[0]')");
	$sth->execute;
	@row = $sth->fetchrow_array;
# </DBI>
    } else {
# <NODBI>
	&file_open("userinfo", "<");
	while (<READFILEUSERINFO>) {
	    chomp;
	    if (/^\Q$_[0]\E;;/i) {
		@row = split(/;;/);
		last;
	    }
	}
	&file_close("userinfo", "<");
# </NODBI>
    }

    $userinfo{'realname'}  = $row[1];
    $userinfo{'email'}     = $row[2];
    $userinfo{'age'}       = $row[3];
    $userinfo{'city'}      = $row[4];
    $userinfo{'country'}   = $row[5];
    $userinfo{'url'}       = $row[6];
    $userinfo{'stuff'}     = $row[7];
    $userinfo{'photo_url'} = $row[8];
    $userinfo{'icq_uin'}   = $row[9];
}

# process safile, add own entry or remove old ones
sub saprocess {	# 0 - name, 1 - room, 2 - don't loop
    my $oldts = $timestamp - $sa_timeout;
    
    if ($use_dbi) {
# <DBI>
	# refresh own entry
	if ($_[0]) {
	    $dbh->do("UPDATE $data{'stillalive'} SET sa_timestamp = $timestamp WHERE Lower(name) = Lower('$_[0]')");
	}
	# change room
	if ($_[1]) {
	    $dbh->do("UPDATE $data{'stillalive'} SET room = $_[1] WHERE Lower(name) = Lower('$_[0]')");
	}
	
	# remove old entries
	my $sth = $dbh->prepare("SELECT name FROM $data{'stillalive'} WHERE sa_timestamp < $oldts");
	$sth->execute;
	
	while (my $row = $sth->fetchrow_arrayref) {
	    &logfile("[LOGOUT] $session{'name'} (timeout)", 2);
	    #print logout msg
	    &postmsg("command", "LOGOUT", "", &msgargs($msg{'hltct'}, [$$row[0]]));
	}
	
	$dbh->do("DELETE FROM $data{'stillalive'} WHERE sa_timestamp < $oldts");
# </DBI>
    } else {
# <NODBI>
	&file_open("stillalive", ">");

	# refresh own entry
	# remove old entries (older than 120 secs)
	my (@sarow, $sarow);
	while ($sarow = <READFILESTILLALIVE>) {
	    chomp($sarow);
	    @sarow = split(/;;/, $sarow);
	    if ($_[0] and $sarow[0] =~ /^\Q$_[0]\E$/i) {
		$sarow[1] = $timestamp;
		# change room
		if ($_[1]) {
		    $sarow[12] = $_[1];
		}
		$sarow = join(';;', @sarow);
		print WRITEFILESTILLALIVE "$sarow\n";
	    } elsif ($sarow[1] >= $oldts) {
		print WRITEFILESTILLALIVE "$sarow\n";
	    } else {
		&logfile("[LOGOUT] $session{'name'} (timeout)", 2);
		#print logout msg
		&postmsg("command", "LOGOUT", "", &msgargs($msg{'hltct'}, [$sarow[0]]));
	    }
	}
	&file_close("stillalive", ">");
# </NODBI>
    }
}


sub usernames {
    &saprocess;
    if ($use_dbi) {
# <DBI>
	my $sth = $dbh->prepare("SELECT name FROM $data{'stillalive'}");
	$sth->execute;
	while (my $row = $sth->fetchrow_arrayref) {
	    print "$$row[0]<BR>\n";
	}
# </DBI>
    } else {
# <NODBI>
	&file_open("stillalive", "<");
	while (<READFILESTILLALIVE>) {
	    chomp;
	    my @row = split(/;;/);
	    print "$row[0]";
	    if ($room) {
		print " ($rooms{$row[12]})";
	    }
	    print "<BR>\n";
	}
	&file_close("stillalive", "<");
# </NODBI>
    }
}

sub postmsg {			# 0 type, 1 from, 2 to, 3 message
    my $pm_type = $_[0];
    my $pm_from = $_[1];
    my $pm_to = $_[2];
    my $pm_message = $_[3];
    
    if ($pm_message) {
	# checking recipient (if set), checking sender, too, for preventing infinite loop
	if ($pm_to and not &nick_exists($pm_to) and &nick_exists($pm_from)) {
	    &postmsg("command", "MSG", $session{'name'}, &msgargs($msg{'unf'}, [$pm_to]));
	} else {
	    my $message_id = time.".$$.";
	    for (my $n=0; $n<3; $n++) { 
		$message_id .= chr(int(rand(26))+65); 
	    }

	    # kill linebreaks
	    $pm_message =~ s/\n/ /g;

 	    my $msg;
	    if ($pm_type eq "public") {
		# LOG PUBLIC MSG
		&logfile("[MSG] $session{'name'}: $pm_message", 3);

		# remove old public messages
		if ($use_dbi) {
# <DBI>
		    $sth = $dbh->prepare("SELECT message_timestamp FROM $data{'messages'} WHERE type='public' AND room=$session{'room'} ORDER BY message_timestamp DESC");
		    $sth->execute;
		    my $i = 1;
		    while (my $row = $sth->fetchrow_arrayref) {
			$i++;
			if ($i >= $message_limit) {
			    $dbh->do("DELETE FROM $data{'messages'} WHERE message_timestamp<$$row[0] AND room=$session{'room'}");
			    last;
			}
		    }
# </DBI>
		} else {
# <NODBI>
		    &file_open("messages", ">");
		    my @messages = <READFILEMESSAGES>;
		    my @messages2;
		    my $i = 1;

		    while (@messages) {
			my $temp = pop @messages;
			my @temp = split(/;;/, $temp);
			unshift @messages2, $temp if ($i < $message_limit or $temp[6] != $session{'room'});
			$i++ if ($temp[0] eq "public");
		    }
		    foreach (@messages2) {
			print WRITEFILEMESSAGES;
		    }
		    &file_close("messages", ">");
# </NODBI>
		}
		
		$pm_message = &wash_msg($pm_message);
		$msg = "<B>$pm_from</B>: $pm_message";
	    } elsif ($pm_type eq "private") {
		$pm_message = &wash_msg($pm_message);
		$msg = "<B>[$pm_from]</B> $pm_message";
	    } elsif ($pm_type eq "private_out") {
		$pm_message = &wash_msg($pm_message);
		$msg = "<B>[->$pm_from]</B> $pm_message";
	    } elsif ($pm_type eq "action") {
		$msg = "$pm_message";
	    } elsif ($pm_type eq "command") {
		$msg = "<B>[$pm_from]</B> $pm_message";
	    } elsif ($pm_type eq "memo") {
		$msg = "<B>[$pm_from]</B> $pm_message";
	    } elsif ($pm_type eq "me") {
		$pm_message = &wash_msg($pm_message);
		$msg = "<B>*$pm_from $pm_message</B>";
	    } elsif ($pm_type eq "plain") {
		$msg = "$pm_message";
	    }
	    
	    if ($query{'selected_action'}) {  
		$msg = "<IMG SRC=\"$actions{$query{'selected_action'}}\" ALIGN=LEFT>$msg";
	    }
	    if ($posting_time) {
		$msg = strftime($posting_time_format, localtime($timestamp))." $msg";
	    }
	    if ($session{'color'} ne "standard" and $pm_type =~ /^(public|private|private_out|memo|me)$/) {
		$msg = "<FONT COLOR=\"#$session{'color'}\">$msg</FONT>";
	    }
	
	    # remove old private messages
	    if ($pm_to) {
		if ($use_dbi) {
# <DBI>
		    $sth = $dbh->prepare("SELECT message_timestamp FROM $data{'messages'} WHERE message_to='$pm_to' ORDER BY message_timestamp DESC");
		    $sth->execute;
		    my $i = 1;
		    while (my $row = $sth->fetchrow_arrayref) {
			$i++;
			if ($i >= $message_limit) {
			    $dbh->do("DELETE FROM $data{'messages'} WHERE message_timestamp<$$row[0] AND message_to='$pm_to'");
			    last;
			}
		    }
# </DBI>
		} else {
# <NODBI>
		    &file_open("messages", ">");
		    my @messages = <READFILEMESSAGES>;
		    my @messages2;
		    my $i = 1;
		    while (@messages) {
			my $temp = pop @messages;
			my @temp = split(/;;/, $temp);
			unshift @messages2, $temp if ($i < $message_limit or !$temp[2]);
			$i++ if (lc($temp[2]) eq lc($_[2]));
		    }
		    foreach (@messages2) {
			print WRITEFILEMESSAGES;
		    }
		    &file_close("messages", ">");
# </NODBI>

		}
	    }

	    if ($use_dbi) {
# <DBI>
		$msg =~ s/\'/&\#39;/g;
		$sth = $dbh->do("INSERT INTO $data{'messages'} VALUES ('$pm_type', '$pm_from', '$pm_to', '$msg', $timestamp, '$message_id', $session{'room'})"); 
# </DBI>
	    } else {
# <NODBI>
		&file_open("messages", "a");
		print APPENDFILEMESSAGES "$pm_type;;$pm_from;;$pm_to;;$msg;;$timestamp;;$message_id;;$session{'room'}\n";
		&file_close("messages", "a");
# </NODBI>
	    }
	}
    }
}

sub wash_msg { # $_[0] msg to 'wash'
    &quote($_[0]);

    # link urls
    # *://* (eg. http or ftp
    $_[0] =~ s/(\b\w*:\/\/[^\ \"]+)/<A HREF=\"$scriptgu_name?$1\" TARGET=\"_blank\">$1<\/A>/g;
    
    # mailto:*
    $_[0] =~ s/(\bmailto:.+\b)/<A HREF=\"$1\">$1<\/A>/g;
    
    # Bad Word Filter
    foreach (@bad_words) {
	$_[0] =~ s/\Q$_\E/$filter/gi;
    }

    # Smileys / Replace
    while ((my $key, my $value) = each %replace) {
	&kill_special_chars($key);
	&kill_special_chars($value);
	$_[0] =~ s/\Q$key\E/$value/g;
    }

    return $_[0];
}

sub kill_special_chars {
    # kill ;
    $_[0] =~ s/;/&\#59;/g;
    # kill '
    $_[0] =~ s/\'/&\#39;/g;
    # kill \
    $_[0] =~ s/\\/&\#92;/g;
}

sub quote { # quote special characters
    &kill_special_chars($_[0]);
    # kill html-tags
    $_[0] =~ s/</&lt\;/g;
    $_[0] =~ s/>/&gt;/g;
    $_[0] =~ s/\"/&quot;/g;

    # kill linebreaks
    $_[0] =~ s/(\n|\r\n|\r)/<BR>/g;
    
    # kill trailing ;
    $_[0] =~ s/;$/; /g;
}

sub unquote { # unquote special characters
    $_[0] =~ s/<BR>/\n/g;
}

sub nick_exists {		# 0 nick
    if ($use_dbi) {
	# <DBI>
	my $sth = $dbh->prepare("SELECT name FROM $data{'nicks'} WHERE Lower(name) = Lower('$_[0]')");
	$sth->execute;
	if ($sth->fetchrow_array) {
	    return 1;
	} else {
	    return 0;
	}
	# </DBI>
    } else {
	# <NODBI>
	&file_open("nicks", "<");
	while(<READFILENICKS>) {
	    if (/^\Q$_[0]\E;;/i) {
		&file_close("nicks", "<");
		return 1;
	    }
	}
	&file_close("nicks", "<");
	return 0;
	# </NODBI>
    }
}

# <DBI>
sub connect_db {
    # connect to database
    $dbh = DBI->connect($dbi_dsn, $dbi_user, $dbi_password, { AutoCommit => 1, RaiseError => 1, PrintError => 1 });

}
# </DBI>

sub number_of_users {
    &saprocess;

    if ($use_dbi) {
# <DBI>
	my $sth = $dbh->prepare("SELECT name FROM $data{'stillalive'}");
	$sth->execute;
	my $sa = $sth->fetchall_arrayref;

	return scalar(@$sa);
# </DBI>
    } else {
# <NODBI>
	&file_open("stillalive", "<");
	my @sa = <READFILESTILLALIVE>;
	&file_close("stillalive", "<");
	return scalar(@sa);
# </NODBI>
    }
}

sub logfile { # 0 - text, 1 - loglevel
    if ($logtype >= $_[1]) {
        open (LOGFILE, ">>$log_dir/".strftime("%Y-%m-%d", localtime($timestamp)).".txt");
#        flock(LOGFILE,2) if ($flocking);
	seek(LOGFILE,0,2);
        print LOGFILE strftime("%Y-%m-%d %T", localtime($timestamp))."	$ENV{'REMOTE_ADDR'}	$$	$_[0]\n";
        close LOGFILE;
    }
}

sub file_open { # 0 - file, 1 - mode (>, < or a)
    my $wfh = "WRITEFILE".uc($_[0]);
    my $afh = "APPENDFILE".uc($_[0]);
    my $rfh = "READFILE".uc($_[0]);
    
    # wait until other process finished working on the file
    my ($file_tmp, $mtime, $mtime2);

    $mtime = (stat("$data_dir/$data{$_[0]}.tmp"))[9];

    $file_tmp = 0;
    while (-e "$data_dir/$data{$_[0]}.open") { 
	sleep 1; 
	$file_tmp++;
	if ($file_tmp > 60) {
	    unlink("$data_dir/$data{$_[0]}.open");
	}
    }
    open(OPENFILE, ">$data_dir/$data{$_[0]}.open");
    close OPENFILE;

    $file_tmp = 0;
    while (-e "$data_dir/$data{$_[0]}.tmp") { 
	sleep 1;
	$file_tmp++;
	
	&logfile("[FILE] $_[1]: $_[0].tmp	found	($mtime)	time=$file_tmp",5);
	
	if ($file_tmp > 60) {
	    $mtime2 = (stat("$data_dir/$data{$_[0]}.tmp"))[9];
	    if ($mtime == $mtime2) {
		unlink("$data_dir/$data{$_[0]}.tmp");		
		&logfile("[FILE] $_[1]: $_[0].tmp	deleted 	($mtime/$mtime2)",4);
	    } else {
		&logfile("[FILE] $_[1]: $_[0].tmp	not deleted 	($mtime/$mtime2)",4);
	    }
	    $file_tmp = 0;
	}
    }

    open($wfh, ">$data_dir/$data{$_[0]}.tmp");
    if ($backup_fil{$_[0]}) {
        print $wfh "FILEOK$_[1]\n";
    }

    unlink("$data_dir/$data{$_[0]}.open");
    
    if ((-s "$data_dir/$data{$_[0]}" < 8 or not -e "$data_dir/$data{$_[0]}") and $backup_fil{$_[0]}) {
	&logfile("[FILE] $_[1]: $_[0]	not ok",4);
	if (not -e "$data_dir/$data{$_[0]}.bak") {
	    open(OKFILE, ">$data_dir/$data{$_[0]}");
	    print OKFILE "FILEOK$_[0]\n";
	    close OKFILE;
	    &logfile("[FILE] $_[1]: $_[0]	(re)created",4);
	} else {
	    &logfile("[FILE] $_[1]: $_[0]	restored from backup",4);
	    copy("$data_dir/$data{$_[0]}.bak", "$data_dir/$data{$_[0]}");
	}
    }

    if ($_[1] eq "a") {
        open($afh, ">>$data_dir/$data{$_[0]}");
        seek($afh,0,2);
    } else {
        open($rfh, "<$data_dir/$data{$_[0]}");
	if ($backup_fil{$_[0]}) {
	    <$rfh>;
	}
    }
}

sub file_close { # 0 - file, 1 - mode (a=append/>>, !=abort, c=close files, r=rename temp, d=delete temp)
    my $wfh = "WRITEFILE".uc($_[0]);
    my $afh = "APPENDFILE".uc($_[0]);
    my $rfh = "READFILE".uc($_[0]);

    if ($_[1] =~ /[<>a!c]/) {
        close $wfh;
    }
    if ($_[1] =~ /[a]/) {
        close $afh;
    }
    if ($_[1] =~ /[<>!c]/) {
        close $rfh;
    }
    if ($_[1] =~ /[>r]/) {
	if ($backup_fil{$_[0]}) {
	    copy("$data_dir/$data{$_[0]}.tmp", "$data_dir/$data{$_[0]}.bak");
	}
	rename("$data_dir/$data{$_[0]}.tmp", "$data_dir/$data{$_[0]}");
    }
    if ($_[1] =~ /[<a!d]/) {
	unlink("$data_dir/$data{$_[0]}.tmp");
    }
}

sub select_room {
    my ($selected);
    print "<SELECT NAME=\"room\">\n";
    while ((my $key, my $value) = each %rooms) {
        if ($key == $session{'room'}) {
	    $selected = "SELECTED";
        } else {
	    $selected = "";
	}
	print "<OPTION VALUE=\"$key\" $selected>$value</OPTION>\n";
    }
    print "</SELECT>\n";
}

sub msgargs { # replace arguments in message: 0 - msg, 1 - args
    my $msg = $_[0];
    $msg =~ s/~~(\d+)~~/$_[1][$1]/g;
    return $msg;
}

sub remove_nick { # remove nick $_[0] or all nicks older than $_[1]
    my $removed_users;
    my $removed_users_names;
    my $oldtime = time - $_[1]*60*60*24;
    if ($use_dbi) {
# <DBI>
	my $sth;
	if ($_[1]) {
	    $sth = $dbh->prepare("SELECT name FROM $data{'nicks'} WHERE lvd < $oldtime");
	} elsif ($_[0]) {
	    $sth = $dbh->prepare("SELECT name FROM $data{'nicks'} WHERE Lower(name) = Lower('$_[0]')");
	}

	$sth->execute();
	while ($_ = $sth->fetchrow_hashref) {
	    $removed_users_names .= " $$_{'name'}";
	    $removed_users++;

	    # remove memos
	    $dbh->do("DELETE FROM $data{'memo'} WHERE Lower(memo_to) = Lower('$$_{'name'}')");

	    # remove userinfo
	    $dbh->do("DELETE FROM $data{'userinfo'} WHERE Lower(name) = Lower('$$_{'name'}')");
	}

	# remove nicks
	if ($_[1]) {
	    $dbh->do("DELETE FROM $data{'nicks'} WHERE lvd < $oldtime");
	} elsif ($_[0]) {
	    $dbh->do("DELETE FROM $data{'nicks'} WHERE Lower(name) = Lower('$_[0]')");
	}
# </DBI>
    } else {
# <NODBI>
	&file_open("nicks", ">");
	
	my @row;
	while (<READFILENICKS>) {
	    @row = split(/;;/);
	    if (($_[0] and lc($row[0]) eq lc($_[0])) or ($_[1] and $row[4] < $oldtime)) {
		$removed_users_names .= " $row[0]";
		$removed_users++;

		&file_open("memo", ">");
		while (<READFILEMEMO>) {
		    if (!/^\Q$row[0]\E;;/i) {
			print WRITEFILEMEMO;
		    }
		}
		&file_close("memo", ">");		
		
		&file_open("userinfo", ">");
		while (<READFILEUSERINFO>) {
		    if (!/^\Q$row[0]\E;;/i) {
			print WRITEFILEUSERINFO;
		    }
		}
		&file_close("userinfo", ">");
	    } else {
		print WRITEFILENICKS;
	    }
	}
	
	&file_close("nicks", ">");
# </NODBI>
    }

    if ($_[1]) {
	if ($removed_users) {
	    &logfile("[CLEAN_OLD_NICKS] $msg{'ru'}: $removed_users_names", 1);
	}
    } elsif ($_[0]) {
	if ($removed_users) {
	    &postmsg("command", "REMOVE_NICK", "$session{'name'}","$msg{'user'} $_[0] $msg{'remov'}");
	    &logfile("[REMOVE_NICK] $_[0] $msg{'remov'}", 1);
	} else {
	    &postmsg("command", "REMOVE_NICK", "$session{'name'}","$msg{'user'} $_[0] $msg{'dne'}");
	}
    }
}


1;

# EOF
